package exam.hardware;

import java.util.*;

import android.app.*;
import android.content.*;
import android.graphics.*;
import android.hardware.*;
import android.os.*;
import android.view.*;

public class hard_Accelerator extends Activity {
	SensorManager mSm;
	AcceleratorView mView;
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		mView = new AcceleratorView(this);
		setContentView(mView);
		
		mSm = (SensorManager)getSystemService(Context.SENSOR_SERVICE);
	}
	
    protected void onResume() {
        super.onResume();
		mSm.registerListener(mView, mSm.getDefaultSensor(Sensor.TYPE_ACCELEROMETER), 
				SensorManager.SENSOR_DELAY_FASTEST);
    }
    
    protected void onPause() {
        super.onPause();
		mSm.unregisterListener(mView);
    }
    
    class AccelValue {
		float x;
		float y;
		float z;
	}

	class AcceleratorView extends View implements SensorEventListener {
		int width;
		int height;
		int w10;
		ArrayList<AccelValue> arValue = new ArrayList<AccelValue>();
		final static int MAGX = 2;
		final static int MAGY = 1;
		boolean mStop = false;
		
		public AcceleratorView(Context context) {
			super(context);
		}

		public void onSizeChanged(int w, int h, int oldw, int oldh) {
            super.onSizeChanged(w, h, oldw, oldh);
			width = w;
			height = h;
			w10 = width/10;
        }

		public void onAccuracyChanged(Sensor sensor, int accuracy) {
		}

		public void onSensorChanged(SensorEvent event) {
			if (mStop) {
				return;
			}
			float[] v = event.values;
			switch (event.sensor.getType()) {
			case Sensor.TYPE_ACCELEROMETER:
				if (arValue.size() * MAGY > height) {
					arValue.clear();
				}
				AccelValue av = new AccelValue();
				av.x = v[0];
				av.y = v[1];
				av.z = v[2];
				arValue.add(av);
				invalidate();
				break;
			}
		}

        public void onDraw(Canvas canvas) {
			Paint Pnt = new Paint();
			Pnt.setColor(Color.WHITE);
			Pnt.setTextSize(20);
			Paint linePaint = new Paint();
			linePaint.setColor(0xff404040);
			
			int i;
			int x, y;
			int oldx, oldy;
			int basex;

			// X 가속 그림
			basex = oldx = w10 * 2;
			oldy = 0;
			canvas.drawText("X", basex - 25, 25, Pnt);
			canvas.drawLine(basex, 0, basex, height, linePaint);
			for (i = 0;i < arValue.size();i++) {
				x = (int)(basex + arValue.get(i).x * MAGX);
				y = i * MAGY;
				canvas.drawLine(oldx, oldy, x, y, Pnt);
				oldx = x;
				oldy = y;
			}

			// Y 가속 그림
			basex = oldx = w10 * 5;
			oldy = 0;
			canvas.drawText("Y", basex - 25, 25, Pnt);
			canvas.drawLine(basex, 0, basex, height, linePaint);
			for (i = 0;i < arValue.size();i++) {
				x = (int)(basex + arValue.get(i).y * MAGX);
				y = i * MAGY;
				canvas.drawLine(oldx, oldy, x, y, Pnt);
				oldx = x;
				oldy = y;
			}

			// Z 가속 그림
			basex = oldx = w10 * 8;
			oldy = 0;
			canvas.drawText("Z", basex - 25, 25, Pnt);
			canvas.drawLine(basex, 0, basex, height, linePaint);
			for (i = 0;i < arValue.size();i++) {
				x = (int)(basex + (arValue.get(i).z - SensorManager.STANDARD_GRAVITY) * MAGX);
				y = i * MAGY;
				canvas.drawLine(oldx, oldy, x, y, Pnt);
				oldx = x;
				oldy = y;
			}
		}
        
		public boolean onTouchEvent(MotionEvent event) {
			if (event.getAction() == MotionEvent.ACTION_DOWN) {
				mStop = !mStop;
				return true;
			}
			return false;
		}
	}
}
