package exam.hardware;

import android.app.*;
import android.content.*;
import android.hardware.*;
import android.os.*;
import android.widget.*;

public class hard_getOrientation extends Activity {
	SensorManager mSm;
	int mOrientCount;
	TextView mTxtOrient;
	float[] mGravity = null;
	float[] mGeoMagnetic = null;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.hard_getorientation);

		mSm = (SensorManager)getSystemService(Context.SENSOR_SERVICE);
		mTxtOrient =(TextView)findViewById(R.id.result);
	}
	
    protected void onResume() {
        super.onResume();
		mSm.registerListener(mSensorListener, mSm.getDefaultSensor(
				Sensor.TYPE_ACCELEROMETER), SensorManager.SENSOR_DELAY_UI);
		mSm.registerListener(mSensorListener, mSm.getDefaultSensor(
				Sensor.TYPE_MAGNETIC_FIELD), SensorManager.SENSOR_DELAY_UI);
    }
    
    protected void onPause() {
        super.onPause();
        mSm.unregisterListener(mSensorListener);
    }
    
    SensorEventListener mSensorListener = new SensorEventListener() {
		public void onAccuracyChanged(Sensor sensor, int accuracy) {
		}

		public void onSensorChanged(SensorEvent event) {
			switch (event.sensor.getType()) {
			case Sensor.TYPE_ACCELEROMETER: 
				mGravity = event.values.clone(); 
				break; 
			case Sensor.TYPE_MAGNETIC_FIELD: 
				mGeoMagnetic = event.values.clone(); 
				break; 
			}
			
			// 둘 다 조사되어 있을 때만
			if (mGravity != null && mGeoMagnetic != null) {
	            float[] R = new float[16]; 
	            SensorManager.getRotationMatrix(R, null, mGravity, mGeoMagnetic);

	            float[] values = new float[3];
	            SensorManager.getOrientation(R, values);
	 
				mTxtOrient.setText("방향 = " + mOrientCount++ + "회" + 
						"\nazimuth:" + Radian2Degree(values[0]) + 
						"\npitch:" + Radian2Degree(values[1]) + 
						"\nroll:" + Radian2Degree(values[2]));
			}
		}
	};
	
	float Radian2Degree(float radian) {
		return radian * 180 / (float)Math.PI;
	}
}